// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::HoverProvider;
use glib::object::Cast;
use glib::object::IsA;
use glib::object::ObjectType as ObjectType_;
use glib::signal::connect_raw;
use glib::signal::SignalHandlerId;
use glib::translate::*;
use glib::StaticType;
use glib::ToValue;
use std::boxed::Box as Box_;
use std::fmt;
use std::mem::transmute;

glib::wrapper! {
    #[doc(alias = "GtkSourceHover")]
    pub struct Hover(Object<ffi::GtkSourceHover, ffi::GtkSourceHoverClass>);

    match fn {
        type_ => || ffi::gtk_source_hover_get_type(),
    }
}

impl Hover {
    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`Hover`] objects.
    ///
    /// This method returns an instance of [`HoverBuilder`](crate::builders::HoverBuilder) which can be used to create [`Hover`] objects.
    pub fn builder() -> HoverBuilder {
        HoverBuilder::default()
    }

    #[doc(alias = "gtk_source_hover_add_provider")]
    pub fn add_provider(&self, provider: &impl IsA<HoverProvider>) {
        unsafe {
            ffi::gtk_source_hover_add_provider(
                self.to_glib_none().0,
                provider.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "gtk_source_hover_remove_provider")]
    pub fn remove_provider(&self, provider: &impl IsA<HoverProvider>) {
        unsafe {
            ffi::gtk_source_hover_remove_provider(
                self.to_glib_none().0,
                provider.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "hover-delay")]
    pub fn hover_delay(&self) -> u32 {
        glib::ObjectExt::property(self, "hover-delay")
    }

    #[doc(alias = "hover-delay")]
    pub fn set_hover_delay(&self, hover_delay: u32) {
        glib::ObjectExt::set_property(self, "hover-delay", &hover_delay)
    }

    #[doc(alias = "hover-delay")]
    pub fn connect_hover_delay_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_hover_delay_trampoline<F: Fn(&Hover) + 'static>(
            this: *mut ffi::GtkSourceHover,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::hover-delay\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_hover_delay_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

#[derive(Clone, Default)]
// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`Hover`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct HoverBuilder {
    hover_delay: Option<u32>,
}

impl HoverBuilder {
    // rustdoc-stripper-ignore-next
    /// Create a new [`HoverBuilder`].
    pub fn new() -> Self {
        Self::default()
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`Hover`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> Hover {
        let mut properties: Vec<(&str, &dyn ToValue)> = vec![];
        if let Some(ref hover_delay) = self.hover_delay {
            properties.push(("hover-delay", hover_delay));
        }
        glib::Object::new::<Hover>(&properties).expect("Failed to create an instance of Hover")
    }

    pub fn hover_delay(mut self, hover_delay: u32) -> Self {
        self.hover_delay = Some(hover_delay);
        self
    }
}

impl fmt::Display for Hover {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Hover")
    }
}
